#ifndef MAIN_H
#define MAIN_H

typedef unsigned int bool;
#define true 1
#define false 0

extern bool main_uses_cc;

typedef enum {
    available,
    waiting,
    leaving,
    transient,
    recycled
} qnode_status;

enum {FIFO_windows, NB_stack_windows, mallocs, NUM_SPECIALS};
extern volatile unsigned long special_events[NUM_SPECIALS];
extern char *special_names[];

/**********************************************************************/

#define compare_and_store(p,o,n) \
    (cas((volatile unsigned long *) (p), \
         (unsigned long) (o), \
         (unsigned long) (n)) == (unsigned long) (o))

#define s_swap(p,v) \
    (qnode_status) swap((volatile unsigned long *) (p), \
        (unsigned long) (v))

#define s_compare_and_swap(p,o,n) \
    (qnode_status) cas((volatile unsigned long *) (p), \
         (unsigned long) (o), \
         (unsigned long) (n))

#endif MAIN_H
