/*
    Define INLINE "storage class" macro and BODY macro that allow us to
    inline separately compiled functions in gcc, but give them real
    bodies in Sun cc.
*/

#ifndef INLINE_H
#define INLINE_H

#ifdef __GNUC__
#define INLINE static __inline__
#define BODY(code) code
#else
#define INLINE extern
#define BODY(code) ;
#endif

#endif INLINE_H
